using System;


// Wrapper for the class generated by the compiler
class WaterSensor {
  public interface Observer {
    void OnStateChange(string newState);
  }

  Cell.Automata.WaterSensor target = new Cell.Automata.WaterSensor();

  public WaterSensor() {
    target.Apply();
  }

  public void FailedReading() {
    target.SetInput(Cell.Automata.WaterSensor.Input.RAW_READING, "nothing");
  }

  public void NewReading(bool value) {
    target.SetInput(Cell.Automata.WaterSensor.Input.RAW_READING, value ? "just(true)" : "just(false)");
  }

  public void Apply(int elapsedSecs, Observer observer) {
    bool done;
    target.SetElapsedSecs(elapsedSecs);
    do {
      done = target.Apply();
      foreach (Cell.Automata.WaterSensor.Output id in target.ChangedOutputs()) {
        string value = target.ReadOutput(id);
        switch (id) {
          case Cell.Automata.WaterSensor.Output.SENSOR_STATE:
            observer.OnStateChange(value);
            break;
        }
      }
    } while (!done);
  }
}


class Writer : WaterSensor.Observer {
  public void OnStateChange(string newValue) {
    Console.WriteLine(newValue.ToString());
  }
}


class Test {
  public static void Main(string[] args) {
    Writer writer = new Writer();
    WaterSensor sensor = new WaterSensor();

    sensor.NewReading(false);
    sensor.Apply(40, writer);

    sensor.FailedReading();
    sensor.Apply(10, writer);

    sensor.FailedReading();
    sensor.Apply(10, writer);

    sensor.FailedReading();
    sensor.Apply(10, writer);

    sensor.NewReading(true);
    sensor.Apply(10, writer);

    sensor.NewReading(false);
    sensor.Apply(50, writer);
  }
}
